using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace MageDefender.GameClasses
{
    public class Enemy
    {
        public bool IsColliding(GameClasses.Spell s)
        {
            bool collision = false;
            Vector3 distance = this.Position - s.Position;
            distance.Y = 0.0f; // Bypass detection on Y

            if (distance.Length() < (this.Radius + s.Radius))
            {
                collision = true;
            }

            return collision;
        }

        public bool IsColliding(Vector3 playerPos)
        {
            //playerPos.Y = 300;

            bool collision = false;
            Vector3 distance = this.Position - playerPos;
            distance.Y = 0.0f; // Bypass detection on Y

            if (distance.Length() < (this.Radius + 200/*Player radius is 200, hardcodeing is bad yeah..*/))
            {
                collision = true;
            }

            return collision;
        }

        bool animated;

        public bool Animated
        {
            get { return animated; }
            set { animated = value; }
        }

        int radius;

        public int Radius
        {
            get { return radius; }
            set { radius = value; }
        }

        bool active;

        public bool Active
        {
            get { return active; }
            set { active = value; }
        }

        Matrix viewMatrix;

        public Matrix ViewMatrix
        {
            get { return viewMatrix; }
            set { viewMatrix = value; }
        }

        Vector3 vecEye;

        public Vector3 VecEye
        {
            get { return vecEye; }
            set { vecEye = value; }
        }

        Vector3 position;

        public Vector3 Position
        {
            get { return position; }
            set { position = value; }
        }
        public float PositionX
        {
            get { return position.X; }
            set { position.X = value; }
        }
        public float PositionY
        {
            get { return position.Y; }
            set { position.Y = value; }
        }
        public float PositionZ
        {
            get { return position.Z; }
            set { position.Z = value; }
        }
        Matrix worldMatrix;

        public Matrix WorldMatrix
        {
            get { return worldMatrix; }
            set { worldMatrix = value; }
        }
        string name;

        public string Name
        {
            get { return name; }
            set { name = value; }
        }
        int modelID;

        public int ModelID
        {
            get { return modelID; }
            set { modelID = value; }
        }

        int baseDamage;

        public int BaseDamage
        {
            get { return baseDamage; }
            set { baseDamage = value; }
        }
        float speed;

        public float Speed
        {
            get { return speed; }
            set { speed = value; }
        }

        GameObjects.EnemyHandler.AI ai;

        public GameObjects.EnemyHandler.AI AI
        {
            get { return ai; }
            set { ai = value; }
        }

        int loot;

        public int Loot
        {
            get { return loot; }
            set { loot = value; }
        }
        int xp;

        public int Xp
        {
            get { return xp; }
            set { xp = value; }
        }
        int score;

        public int Score
        {
            get { return score; }
            set { score = value; }
        }

        float health;

        public float Health
        {
            get { return health; }
            set { health = value; }
        }

        float maxHealth;
        public float MaxHealth
        {
            get { return maxHealth; }
            set { maxHealth = value; }
        }

        bool isDOT;

        public bool IsDOT
        {
            get { return isDOT; }
            set { isDOT = value; }
        }

        List<GameClasses.Spell.Alignments> alignmentsList;

        public List<GameClasses.Spell.Alignments> AlignmentsList
        {
            get { return alignmentsList; }
            set { alignmentsList = value; }
        }
        List<GameClasses.Spell.Alignments> imuneAlignments;

        public List<GameClasses.Spell.Alignments> ImuneAlignments
        {
            get { return imuneAlignments; }
            set { imuneAlignments = value; }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="n">Name</param>
        /// <param name="mID">ModelID</param>
        /// <param name="hP">Hit points</param>
        /// <param name="bD">Base damage</param>
        /// <param name="s">Speed(x,y)</param>
        /// <param name="r">radius</param>
        /// <param name="p">Start position</param>
        /// <param name="aiMode">AI</param>
        /// <param name="l">loot gold</param>
        /// <param name="x">xp when killed</param>
        /// <param name="sc">score</param>
        public Enemy(string n, bool anim, int mID,int hP, int bD, Vector2 s, int r, Vector3 p, GameObjects.EnemyHandler.AI aiMode, int l, int x, int sc)
        {
            alignmentsList = new List<Spell.Alignments>();
            imuneAlignments = new List<Spell.Alignments>();

            Random rndSpeed = new Random();

            speed = (float)(s.X + (rndSpeed.NextDouble()*s.Y));
            baseDamage = bD;
            modelID = mID;
            position = p;
            active = true;
            radius = r;
            ai = aiMode;
            loot = l;
            xp = x;
            score = sc;
            health = hP;
            maxHealth = hP;
            name = n;
            isDOT = false;
            animated = anim;
        }

        public void Update(Vector3 v, Matrix vM)
        {
            Matrix objectMatrix = Matrix.CreateRotationX(0) * Matrix.CreateRotationY(0) * Matrix.CreateTranslation(Position.X, Position.Y, Position.Z);
            Matrix renderMatrix = Matrix.CreateScale(0.0080f);
            worldMatrix = objectMatrix * renderMatrix;
            viewMatrix = vM;
        }
    }
}